from pytracking.utils import TrackerParams
from pytracking.features.net_wrappers import NetWithBackbone

def parameters():
    
    params = TrackerParams()
    print("params chnaged lr 0.04 and 0.08 s= 50!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!")
    params.debug = 0
    params.visualization = False

    params.use_gpu = True

    params.image_sample_size = 18*16
    params.search_area_scale = 5

    # Learning parameters
    
    params.sample_memory_size = 50
    params.learning_rate = 0.01
    params.init_samples_minimum_weight = 0.25
    params.train_skipping = 20

    params.num_erasing = 10 # the number of random erasing images

    # Net optimization params
    params.update_classifier = True
    params.net_opt_iter = 10
    params.net_opt_update_iter = 2
    params.net_opt_hn_iter = 1

    # Detection parameters
    params.window_output = False

    # Init augmentation parameters
    params.use_augmentation = True
    params.augmentation = {'fliplr': True,
                           'rotate': [10, -10, 45, -45],
                           'blur': [(3,1), (1, 3), (2, 2)],
                           'relativeshift': [(0.6, 0.6), (-0.6, 0.6), (0.6, -0.6), (-0.6,-0.6)],
                           'dropout': (2, 0.2)}

    params.augmentation_expansion_factor = 2
    params.random_shift_factor = 1/3

    # Advanced localization parameters
    params.advanced_localization = True
    params.target_not_found_threshold = 0.25
    params.distractor_threshold = 0.8
    params.hard_negative_threshold = 0.5
    params.target_neighborhood_scale = 2.2
    params.dispalcement_scale = 0.8
    params.hard_negative_learning_rate = 0.02
    params.update_scale_when_uncertain = True
    params.ocl_sample_threshold = 0.5

    # IoUnet parameters
    params.iounet_augmentation = False
    params.iounet_use_log_scale = True
    params.iounet_k = 3
    params.num_init_random_boxes = 9
    params.box_jitter_pos = 0.1
    params.box_jitter_sz = 0.5
    params.maximal_aspect_ratio = 6
    params.box_refinement_iter = 5
    params.box_refinement_step_length = 1
    params.box_refinement_step_decay = 1

    params.net = NetWithBackbone(net_path='dimp50.pth',
                                 use_gpu=params.use_gpu)

    params.vot_anno_conversion_type = 'preserve_area'

    params.train_skipping_max = 40

    

    #change detection params
    params.change_det_thresh = 0.1
    params.inital_lr = 0.01
    params.online_lr = 0.01639968334691694
    params.orig_wt = 0.06
    params.gamma = 1.1336405742635864
    params.Nsamples_CD = 8
    params.Aux_mem_len = 50

    params.only_aux_weight = 0.02
   

    return params

"""1.287455533971042
0.013199273805177117
61.20901870727539
"""
#replay_memory
#Trial 12 finished with value: 61.36609649658203 and parameters: {'online_lr': 0.03942975017010647, 'gamma': 1.2301053876625863}. 
# Best is trial 12 with value: 61.36609649658203


#replay_memory_full_Aux
 #Trial 4 finished with value: 61.201194763183594 
 #and parameters: {'online_lr': 0.029067031163436462, 'gamma': 1.3219878017837803}