
from HDDDM_LIB.HDDDM import HDDDM 
import torch
from collections import deque
import numpy as np

class MMDDrift:
    def __init__(self, mmd_method=True, gamma=0.9,baseline_size=7, input_batch=5):
        self.hddm = None #HDDDM(baseline_x, gamma,None,use_mmd2=mmd_method)
        self.batch_x = None
        self.batch_size = baseline_size
        self.baseline_x = None
        self.que_data = deque()
        self.gamma = gamma
        self.use_mmd = mmd_method
        self.input_batch = input_batch

    def _set_baseline(self,input_x):
        if self.baseline_x is None:
            self.baseline_x = input_x.detach().cpu().numpy()

        else:
           
            
            self.baseline_x = np.vstack((self.baseline_x, input_x.detach().cpu().numpy()))
            if self.baseline_x.shape[0]==self.batch_size:
               
                self.hddm = HDDDM(self.baseline_x, gamma=self.gamma,alpha=None,use_mmd2=self.use_mmd)
            


    #add a single feature, 
    def detect_drift(self, input_feature):
        
        if self.baseline_x is None:
            self._set_baseline(input_feature)
            return False

        
        if self.baseline_x.shape[0] < self.batch_size:
            self._set_baseline(input_feature)
            return False
        
        if self.batch_x is None:
            self.batch_x = input_feature.detach().cpu().numpy()
        
        if self.batch_x.shape[0] < self.input_batch:
              self.batch_x = np.vstack((self.batch_x, input_feature.detach().cpu().numpy()))
              return False



        self.hddm.add_batch(self.batch_x)
        self.batch_x = None
        return  self.hddm.detected_change()



    









